package me.regexp;

final class RERange
{
    private int size;
    int[] minRange;
    int[] maxRange;
    int num;
    
    RERange() {
        super();
        this.size = 16;
        this.minRange = new int[this.size];
        this.maxRange = new int[this.size];
        this.num = 0;
    }
    
    private void delete(int n) {
        if (this.num == 0 || n >= this.num) {
            return;
        }
        while (++n < this.num) {
            if (n - 1 >= 0) {
                this.minRange[n - 1] = this.minRange[n];
                this.maxRange[n - 1] = this.maxRange[n];
            }
        }
        --this.num;
    }
    
    private void merge(int n, int n2) {
    Label_0000:
        while (true) {
            for (int i = 0; i < this.num; ++i) {
                if (n >= this.minRange[i] && n2 <= this.maxRange[i]) {
                    return;
                }
                if (n <= this.minRange[i] && n2 >= this.maxRange[i]) {
                    this.delete(i);
                    
                    continue Label_0000;
                }
                if (n >= this.minRange[i] && n <= this.maxRange[i]) {
                    n = this.minRange[i];
                    this.delete(i);
                    
                    continue Label_0000;
                }
                if (n2 >= this.minRange[i] && n2 <= this.maxRange[i]) {
                    n2 = this.maxRange[i];
                    this.delete(i);
                    
                    continue Label_0000;
                }
            }
            if (this.num >= this.size) {
                final RERange class106 = this;
                class106.size <<= 1;
                final int[] anIntArray492 = new int[this.size];
                final int[] anIntArray493 = new int[this.size];
                System.arraycopy(this.minRange, 0, anIntArray492, 0, this.num);
                System.arraycopy(this.maxRange, 0, anIntArray493, 0, this.num);
                this.minRange = anIntArray492;
                this.maxRange = anIntArray493;
            }
            this.minRange[this.num] = n;
            this.maxRange[this.num] = n2;
            final RERange class107 = this;
            ++class107.num;
        }
    }
    
    final void include(final int n, int n2, final boolean b) {
        if (b) {
            this.merge(n, n2);
            return;
        }
        final int n3 = n2;
        n2 = n;
        for (int i = 0; i < this.num; ++i) {
            if (this.minRange[i] >= n2 && this.maxRange[i] <= n3) {
                this.delete(i);
                return;
            }
            if (n2 >= this.minRange[i] && n3 <= this.maxRange[i]) {
                final int n4 = this.minRange[i];
                final int n5 = this.maxRange[i];
                this.delete(i);
                if (n4 < n2) {
                    this.merge(n4, n2 - 1);
                }
                if (n3 < n5) {
                    this.merge(n3 + 1, n5);
                }
                return;
            }
            if (this.minRange[i] >= n2 && this.minRange[i] <= n3) {
                this.minRange[i] = n3 + 1;
                return;
            }
            if (this.maxRange[i] >= n2 && this.maxRange[i] <= n3) {
                this.maxRange[i] = n2 - 1;
                return;
            }
        }
    }
    
    final void include(final char c, final boolean b) {
        this.include(c, c, b);
    }
}
