package vk4me.attachments;

import java.util.*;

import org.json.me.JSONObject;

import deobfDefault.Class2;
import vk4me.objects.Parsable;

public abstract class Attachment extends Parsable
{
    private static Hashtable classes;
    
    public Attachment() {
        super();
    }
    
    public abstract String toString();
    
    public static Attachment getAttachment(final JSONObject j) {
        if (Attachment.classes == null) {
            (Attachment.classes = new Hashtable()).put("photo", new PhotoAtt().getClass());
            Attachment.classes.put("sticker", new StickerAtt().getClass());
            Attachment.classes.put("audio", new AudioAtt().getClass());
            Attachment.classes.put("graffiti", new GraffitiAtt().getClass());
            Attachment.classes.put("doc", new DocAtt().getClass());
            Attachment.classes.put("audio_message", new AudioMessageAtt().getClass());
            Attachment.classes.put("audio_playlist", new PlaylistAtt().getClass());
        }
        String type;
        if (!Class2.isNull(type = j.optString("type")) && Attachment.classes.containsKey(type)) {
            final Class clazz;
            if ((clazz = (Class) Attachment.classes.get(type)) != null) {
                try {
                    return (Attachment)((Attachment)clazz.newInstance()).parse(j.optJSONObject(type));
                }
                catch (Exception ex) {}
            }
            return null;
        }
        return (Attachment)new DefaultAtt(type).parse(j.optJSONObject(type));
    }
}
