package vk4me.objects;

import org.json.me.JSONArray;
import org.json.me.JSONObject;

public final class ChatInfo extends Parsable
{
    public String title;
    public Avatar photo;
    public boolean is_group_channel;
    private int[] active_ids;
    private int[] admin_ids;
    private int owner_id;
    
    public ChatInfo() {
        super();
    }
    
    public final Parsable parse(final JSONObject class21) {
        if (class21 == null) {
            return this;
        }
        this.owner_id = class21.optInt("owner_id");
        class21.optInt("members_count");
        this.title = class21.optString("title");
        class21.optString("state");
        final JSONObject method88;
        if ((method88 = class21.optJSONObject("pinned_message")) != null) {
            new Message().parse(method88);
        }
        final JSONObject method89;
        if ((method89 = class21.optJSONObject("photo")) != null) {
            this.photo = (Avatar)new Avatar().parse(method89);
        }
        this.is_group_channel = class21.optBoolean("is_group_channel");
        final JSONArray method90;
        if ((method90 = class21.optJSONArray("active_ids")) != null) {
            this.active_ids = new int[method90.myArrayList.size()];
            for (int i = 0; i < method90.myArrayList.size(); ++i) {
                this.active_ids[i] = method90.optInt(i);
            }
        }
        final JSONArray method91;
        if ((method91 = class21.optJSONArray("admin_ids")) != null) {
            this.admin_ids = new int[method91.myArrayList.size()];
            for (int j = 0; j < method91.myArrayList.size(); ++j) {
                this.admin_ids[j] = method91.optInt(j);
            }
        }
        return this;
    }
    
    public final boolean hasPhoto() {
        return this.photo != null;
    }
    
    public final boolean isAdmin(final int n) {
        if (this.owner_id == n) {
            return true;
        }
        if (this.admin_ids == null || this.admin_ids.length <= 0) {
            return false;
        }
        for (int i = 0; i < this.admin_ids.length; ++i) {
            if (n == this.admin_ids[i]) {
                return true;
            }
        }
        return false;
    }
}
