package vk4me.objects;

import org.json.me.JSONObject;

import deobfDefault.Class2;
import ru.curoviyxru.j2vk.api.objects.VKObject;

public final class Group extends Profile
{
    private int id;
    public int is_closed;
    public int invited_by;
    private String name;
    private String screen_name;
    public String deactivated;
    private String photo_50;
    private String photo_100;
    public String status;
    public boolean banned;
    public boolean is_member;
    public boolean can_message;
    public int members_count;
    public int audios;
    
    public Group() {
        super(true);
    }
    
    public final String status() {
        return this.status;
    }
    
    public final String photo50() {
        if (!Class2.isNull(this.photo_50)) {
            return this.photo_50;
        }
        return "https://vk.com/images/community_50.png";
    }
    
    public final String photo100() {
        if (!Class2.isNull(this.photo_100)) {
            return this.photo_100;
        }
        return "https://vk.com/images/community_100.png";
    }
    
    public final String getFullName(final String s) {
        return this.name;
    }
    
    public final int local_id() {
        return -this.id;
    }
    
    public final Parsable parse(final JSONObject class21) {
        if (class21 == null) {
            return this;
        }
        this.id = class21.optInt("id");
        this.is_closed = class21.optInt("is_closed");
        class21.optInt("admin_level");
        this.invited_by = class21.optInt("invited_by");
        this.name = class21.optString("name");
        this.screen_name = class21.optString("screen_name");
        this.deactivated = class21.optString("deactivated");
        class21.optString("type");
        this.photo_50 = class21.optString("photo_50");
        this.photo_100 = class21.optString("photo_100");
        this.members_count = class21.optInt("members_count");
        this.is_member = VKObject.fromInteger(class21.optInt("is_member"));
        class21.optInt("is_admin");
        class21.optInt("is_advertiser");
        this.status = class21.optString("status");
        this.can_message = class21.optBoolean("can_message");
        class21.optString("description");
        final JSONObject method88;
        if ((method88 = class21.optJSONObject("ban_info")) != null) {
            this.banned = true;
            method88.optString("comment");
            method88.optInt("reason", -1);
            method88.optInt("end_date");
        }
        final JSONObject method89;
        if ((method89 = class21.optJSONObject("counters")) != null) {
            this.audios = method89.optInt("audios");
        }
        return this;
    }
    
    public final String getShortName(final String s) {
        if (this.name == null || this.name.length() <= 0) {
            return this.name;
        }
        return this.name.charAt(0) + ".";
    }
    
    public final String getScreenName() {
        return this.screen_name;
    }
}
